<?
/*****************************************************************************
* Cookie implementation of GPB                                               *
* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^                                               *
* Is includes in every file, checks the cookies and applies user settings    *
*****************************************************************************/


/*****************************************************************************
* Functie: setcookies                                                        *
* Place the parameters in the usercookies                                    *
*****************************************************************************/
function setcookies($username, $password) {
	global $cookie_secure, $cookie_expire, $cookie_path, $cookie_domain, $cookie_unm, $cookie_w8w;
	$lifetime = time() + $cookie_expire;
	setcookie($cookie_unm, $username, $lifetime, $cookie_path, $cookie_domain, $cookie_secure);
	setcookie($cookie_w8w, $password, $lifetime, $cookie_path, $cookie_domain, $cookie_secure);
}


/*****************************************************************************
* Functie: setlastvisit                                                      *
* Place the timestamp parameters in the last visit cookies                   *
*****************************************************************************/
function setlastvisit ($timestamp) {
	global $cookie_secure, $cookie_expire, $cookie_path, $cookie_domain, $cookie_tms;
	$lifetime = time() + $cookie_expire;
	setcookie($cookie_tms, $timestamp, $lifetime, $cookie_path, $cookie_domain, $cookie_secure);
}


/*****************************************************************************
* Functie: unsetcookies                                                      *
* Delete usercookies by applying a negative timestamp to the expire time     *
*****************************************************************************/
function unsetcookies() {
	global $cookie_secure, $cookie_expire, $cookie_path, $cookie_domain, $cookie_unm, $cookie_w8w, $cookie_tms;
	$lifetime = time() - $cookie_expire;
	setcookie($cookie_unm, '', $lifetime, $cookie_path, $cookie_domain, $cookie_secure);
	setcookie($cookie_w8w, '', $lifetime, $cookie_path, $cookie_domain, $cookie_secure);
	$gpb_username = "";
	$gpb_password = "";
	$logged_in = 0;
}


/*****************************************************************************
* Functie: unsetlastvisit                                                    *
* Delete lastvisit cookie by applying a negative timestamp to the expiretime *
*****************************************************************************/
function unsetlastvisit () {
	global $cookie_secure, $cookie_expire, $cookie_path, $cookie_domain, $cookie_tms;
	$lifetime = time() - $cookie_expire;
	setcookie($cookie_tms, '', $lifetime, $cookie_path, $cookie_domain, $cookie_secure);
}

// Check if a login form has been submitted
if (($txt_username != "") && ($txt_password != "")) {
	$cookie_password = md5($txt_password);
	$legal = user_check($txt_username, $cookie_password);
	if ($legal == 0) {
		$current = time();
		setcookies($txt_username, $cookie_password);
		setlastvisit($current);
		$gpb_username = $txt_username;
		$gpb_password = $cookie_password;
		$user_prefs = user_prefs($gpb_username);
		$logged_in = 1;
	}
	else {
		$logged_in = 0;
	}
}

// Check if a valid cookie exists. If true log the user in
$logged_in = 0;
if (($gpb_username != "") && ($gpb_password != "")) {
	$legal = user_check($gpb_username, $gpb_password);
	// legal = 1 when the username and password combo exists
	if ($legal == 0) {
		setcookies($gpb_username, $gpb_password);
		$user_prefs = user_prefs($gpb_username);
		$logged_in = 1;
	}
}

// No session yet
if ($last_visit == "") {
	// Set last_visit to zero if no cookie exists (everything is new)
	if ($gpb_lastvisit == "") {
		$last_visit = 0;
	}
	// Set last visit to the cookie
	else {
		$last_visit = $gpb_lastvisit;
	}
}
// Register last_visit so that it's value will be saved during the session
session_name();
session_register('last_visit');
// Now we can override the cookie by the current time, we won't use the cookie again while there is a session running
$current = time();
setlastvisit($current);

// Override user theme if allowed
if (($allow_custom_theme == 1) && ($user_prefs->theme != "")) {
	$theme = "themes/".$user_prefs->theme;
}
// Override user language if allowed
if (($allow_custom_language == 1) && ($user_prefs->language != "")) {
	include("$root_path/include/i18n/".$user_prefs->language.".inc.php");
}
// Override default topics per page
if ($user_prefs->show_days != "") {
	$show_topics_days = $user_prefs->show_days;
}
?>