<?
/*                   D A T A - A D D   F U N C T I O N S                      */

/*******************************************************************************
* Function: add_user (...)                                                     *
* Add a new user to the database with tha data provided by the parameters      *
* Returns 'ok' if succeed, else errormsg is returned                           *
*******************************************************************************/
function add_user  ($username, $passwd1, $passwd2, $email, $email_visible,
					$admin_mail, $realname, $occupation, $homepage, $birthday,
					$icq_num, $phone_num, $photo_url, $interests, $residence,
					$signature, $subtitle, $avatar_enable, $avatar_url,
					$language, $theme, $show_days) {
	
	global $username_min_length, $username_max_length, $pwd_min_length, $pwd_max_length;
	
	// Now we do some tests. If all tests succeed, we execute the query
	// to add the user to the database and we return 0. If there where any
	// errors we return an non-zero value, indicationg what's wrong.
	// These non-zero values are:
	// 1: username too short or too long
	// 2: username contains illegal characters
	// 3: passwd1 and passwd2 are not identic
	// 4: passwd too short
	// 5: passwd to long
	// 6: invalid emailaddress
	// 7: username already in use
	// 8: emailaddress already in use
	// 9: unknown database error
	
	// Check if username is too short
	if (strlen ($username) < $username_min_length) {
		return 1;
	}
	
	// Check if username is too long
	if (strlen ($username) > $username_max_length) {
		return 1;
	}
	
	// Check if username contains illegal characters
	$ill_chars = '<>/';
	for ($i=0; $i<strlen($ill_chars); $i++) {
		for ($j=0; $j<strlen($username); $j++) {
			if (substr($ill_chars, $i, 1) == substr($username, $j, 1)) {
				return 2;
			}
		}
	}
	
	// Check if passwd1 and passwd2 are identic
	if ($passwd1 != $passwd2) {
		return 3;
	}
	
	// Check if passwd is too short
	if (strlen ($passwd1) < $pwd_min_length) {
		return 4;
	}
	
	// Check if username is too long
	if (strlen ($passwd1) > $pwd_max_length) {
		return 5;
	}
	
	// Check if emailaddress is valid
	if (!valid_email ($email)) {
		return 6;
	}
	
	// Check if username is already in use
	if (user_exists ($username) == 0) {
		return 7;
	}
	
	// Check if emailaddress is already in use
	if (email_exists ($email) == 0) {
		return 8;
	}
	
	// Get the time
	$reg_timestamp = time();
	
	// default status is 'Member'
	$status = _MEMBER_;
	
	// encrypt the passwd
	$md5passwd = md5($passwd1);
	
	gpb_connect ();
	
	$query =   "INSERT INTO gpb_user
				VALUES (null, '$md5passwd', '$username', '$realname',
						'$email', '$homepage', '$icq_num',
						'$phone_num', '$birthday', '$status',
						'$reg_timestamp', '$occupation',
						'$interests', '$residence', '$signature',
						'$subtitle', '$photo_url', '$avatar_url',
						'$language', '$theme', '$show_days',
						'$email_visible', '$admin_mail',
						'$avatar_enable', 0, 0)";
	$result = mysql_query ($query);
	
	gpb_close();
	
	if (!$result) {
		return 9;
	}
	
	return 0;
}


/*******************************************************************************
* Functie: add_category (...)                                                  *
* Add new category to forum                                                    *
*******************************************************************************/
function add_category ($ctitle, $pos) {
	
	global $logged_in, $user_prefs;
	
	// Now we do some tests. If all tests succeed, we execute the query
	// to add the category to the database and we return 0. If there where any
	// errors we return an non-zero value, indicationg what's wrong.
	// These non-zero values are:
	// 0: category succesfully added
	// 1: no user logged in
	// 2: user don't have enough rights to add a category (status < 3)
	// 3: no title given
	// 9: unknown database error
	
	$ctitle = trim($ctitle);
	
	// Check if the user is loggedin
	if ($logged_in != 1) {
		return 1;
	}
	
	// Check if user has enough rights (status must be Admin)
	if ($user_prefs->status < _ADMINISTRATOR_) {
		return 2;
	}
	
	// Check if there is a title given
	if ($ctitle == "") {
		return 3;
	}
	
	// Everthing's okay, let's add the category
	gpb_connect();
	$query = "INSERT INTO gpb_cat VALUES (null, '$ctitle', '$pos')";
	$result = mysql_query ($query);
	gpb_close();
	if (!$result) {
		return 9;
	}
	
	return 0;
}


/*******************************************************************************
* Function: add_subcategory (...)                                              *
* Add new subcategory to a given category                                      *
*******************************************************************************/
function add_subcategory ($cid, $stitle, $description, $abbrev, $mod_uid, $mod_only, $pos) {
	
	// Now we do some tests. If all tests succeed, we execute the query
	// to add the subcategory to the database and we return 0. If there where any
	// errors we return an non-zero value, indicationg what's wrong.
	// These non-zero values are:
	// 1: no user logged in
	// 2: user has not enough rights to add subcategory (status < 3)
	// 3: no/invalid category given
	// 4: no/invalid stitle given
	// 5: invalid mod_only value
	// 6: no/invalid moderator_uid given
	// 7: no/invalig pos given
	// 9: unknown database error
	
	global $logged_in, $user_prefs;
	
	$stitle = trim($stitle);
	$description = trim($description);
	$abbrev = trim($abbrev);
	
	// Check if the user is loggedin
	if ($logged_in != 1) {
		return 1;
	}
	
	// Check if user has enough rights (status must be Admin)
	if ($user_prefs->status < _ADMINISTRATOR_) {
		return 2;
	}
	
	// Check if there is a cid given
	if (empty ($cid)) {
		return 3;
	}
	
	// Check if the given cid is valid
	gpb_connect ();
	$query = "SELECT cid FROM gpb_cat WHERE cid=$cid";
	$result = mysql_query ($query);
	gpb_close;
	if (!$result) {
		return 3;
	}
	
	if ($stitle == "") {
		return 4;
	}
	
	// Check if mod_only value is valid
	if (($mod_only != 0) && ($mod_only != 1)) {
		return 5;
	}
	
	// Check if there is a mod_uid given
	if (empty ($mod_uid)) {
		return 6;
	}
	
	// Check if the given mod_uid is valid
	gpb_connect ();
	$query = "SELECT uid, status FROM gpb_user WHERE uid='$mod_uid' AND status > 1";
	$result = mysql_query ($query);
	gpb_close;
	if (!$result) {
		return 6;
	}
	
	// Check if pos is empty
	if ($pos == "") {
		return 7;
	}
	
	// Everything is fine, so let's add the subcategorie to the database
	gpb_connect();
	$query = "INSERT INTO gpb_subcat VALUES ('null', '$cid', '$mod_only', '$stitle', '$description', '$abbrev', '0', '0', '0', '$mod_uid', '$pos');";
	$result = mysql_query ($query);
	gpb_close();
	if (!$result) {
		return 9;
	}
	
	return 0;
}


/*******************************************************************************
* Functie: add_topic (...)                                                     *
* Add new topic to subcategory (that includes also 1 post!!)                   *
*******************************************************************************/
function add_topic ($sid, $username, $password, $ttitle, $text, $icon, $enable_smilies, $mail_on_reply) {
	
	global $ttitle_min_length;
	
	// Now we do some tests. If all tests succeed, we execute some queries
	// to add the topic, the post and to update te subcategory and the user
	// and return the value "0". If there where any errors we return an
	// non-zero values, indicating what's wrong.
	// These non-zero values are:
	// 1: user not logged in
	// 2: no title given
	// 3: no text in the body
	// 4: no subcategory ID (sid) given in URL
	// 5: invalid subcategory ID (sid) given in URL
	// 6: user has no rights to post in this (mod_only) subcat
	// 9: unknown database error
	
	$ttitle = trim($ttitle);
	$text = trim($text);
	
	// Check if username and password combo is valid
	$legal = user_check($username, $password);
	if ($legal != 0) {
		return 1;
	}
	
	// Check if there is a title given
	if (strlen ($ttitle) < $ttitle_min_length) {
		return 2;
	}
	
	// Check if there is a text in the body
	if ($text == "") {
		return 3;
	}
	
	// Check if there is a sid given
	if ($sid == "") {
		return 4;
	}
	
	// Check if the given sid is valid
	gpb_connect ();
	$query = "SELECT sid FROM gpb_subcat WHERE sid=$sid;";
	$result = mysql_query ($query);
	gpb_close;
	if (!$result) {
		return 5;
	}
	
	// Check if subcat is mod_only and users-status < moderator
	$this_subcat = info_by_sid ($sid);
	$this_user = user_prefs ($username);
	if (($this_subcat->moderator_only == 1) && ($this_user->status < _MODERATOR_)) {
		return 6;
	}
	
	// If there's a iconless theme, we'll put icon1 as the post icon
	if ($icon == "") {
		$icon = 1;
	}
	
	// We need the userID, not the username, so convert it :)
	$uid = username_to_uid($username);
	
	// ... and the timestamp ...
	$timestamp = time();
	
	gpb_connect ();
	
	// Query to add topic to gpb_topic
	$query = "INSERT INTO gpb_topic VALUES (null, '$sid', '$uid', '$ttitle', '0', '$timestamp', '$icon', '$mail_on_reply', '0', '0')";
	mysql_query ($query);
	
	// To add the post we want to know the tid of the new topic, so:
	$query = "SELECT tid FROM gpb_topic WHERE ttitle='$ttitle' AND sid='$sid' AND uid='$uid' ORDER BY tid DESC LIMIT 1;";
	$result = mysql_query ($query);
	if ($result) {
		while ($row = mysql_fetch_array ($result)) {
			$tid = $row['tid'];
		}
	}
	
	// Query to add post to gpb_post
	$query = "INSERT INTO gpb_post VALUES (null, '$tid', '$uid', '$text', '$timestamp', '1', '$icon', '$enable_smilies');";
	mysql_query ($query);
	
	// Now we want to know the pid of the new posted post, so:
	$query = "SELECT pid FROM gpb_post WHERE tid='$tid' AND uid='$uid' AND text='$text' AND timestamp='$timestamp';";
	$result = mysql_query ($query);
	if ($result) {
		while ($row = mysql_fetch_array ($result)) {
			$pid = $row['pid'];
		}
	}
	
	// Now we know the pid, we can update the gpb_topic table:
	$query = "UPDATE gpb_topic SET last_pid='$pid', num_posts='1' WHERE tid='$tid';";
	mysql_query ($query);
	
	// Query to update gpb_user
	$query = "UPDATE gpb_user SET num_posts=num_posts+1, last_pid='$pid' WHERE uid='$uid';";
	mysql_query ($query);
	
	// Query to update gpb_subcat
	$query = "UPDATE gpb_subcat SET num_topics=num_topics+1, num_posts=num_posts+1, last_pid='$pid' WHERE sid='$sid';";
	mysql_query ($query);
	
	gpb_close;
	
	return 0;
}


/*******************************************************************************
* Functie: add_post (...)                                                      *
* Add new post to a topic                                                      *
*******************************************************************************/
function add_post ($tid, $username, $password, $text, $icon, $enable_smilies) {
	
	// Now we do some tests. If all tests succeed, we execute some queries
	// to add the topic, the post and to update te subcategory and the user
	// and return the value "0". If there where any errors we return an
	// non-zero values, indicating what's wrong.
	// These non-zero values are:
	// 1: user not logged in
	// 2: no text in the body
	// 3: no topic ID (tid) given in URL
	// 4: invalid topic ID (tid) given in URL
	// 5: user has no rights to post in this (mod_only) subcat
	// 9: unknown database error
	
	$text = trim($text);
	
	// Check if username and password combo is valid
	$legal = user_check($username, $password);
	if ($legal != 0) {
		return 1;
	}
	
	// Check if there is a text in the body
	if ($text == "") {
		return 2;
	}
	
	// Check if there is a tid given
	if ($tid == "") {
		return 3;
	}
	
	// Check if the given tid is valid
	gpb_connect ();
	$query = "SELECT tid FROM gpb_topic WHERE tid=$tid;";
	$result = mysql_query ($query);
	gpb_close ();
	if (!$result) {
		return 4;
	}
	
	// Check if subcat is mod_only and users-status < moderator
	$this_topic = info_by_tid($tid);
	$this_subcat = info_by_sid ($this_topic->sid);
	$this_user = user_prefs ($username);
	if (($this_subcat->moderator_only == 1) && ($this_user->status < _MODERATOR_)) {
		return 5;
	}
	
	// If there's an iconless theme, we'll put icon1 as the post icon
	if ($icon == "") {
		$icon = 1;
	}
	
	// Get the uid of the username
	$uid = username_to_uid ($username);
	
	// Get the time
	$timestamp = time ();
	
	// Get the sid belonging to the topic
	$topic = info_by_tid($tid);
	$sid = $topic->sid;
	
	// Query to add post to gpb_post
	gpb_connect ();
	$query = "INSERT INTO gpb_post VALUES (null, '$tid', '$uid', '$text', '$timestamp', '0', '$icon', '$enable_smilies');";
	mysql_query ($query);
	
	// To add the the other tables we want to know the pid of the new post, so:
	$query = "SELECT pid FROM gpb_post WHERE tid='$tid' AND uid='$uid' AND text='$text' AND timestamp='$timestamp' ORDER BY pid DESC LIMIT 1;";
	$result = mysql_query ($query);
	if ($result) {
		while ($row = mysql_fetch_array ($result)) {
			$pid = $row['pid'];
		}
		
		// Update the topic
		$query = "UPDATE gpb_topic SET num_posts=num_posts+1, last_pid='$pid' WHERE tid='$tid';";
		mysql_query ($query);
		
		// Update the subcategory
		$query = "UPDATE gpb_subcat SET num_posts=num_posts+1, last_pid='$pid' WHERE sid='$sid';";
		mysql_query ($query);
		
		// Update the user
		$query = "UPDATE gpb_user SET num_posts=num_posts+1, last_pid='$pid' WHERE uid='$uid';";
		mysql_query ($query);
		
		$status = 0;
	}
	else {
		$status = 9;
	}
	gpb_close();
	return $status;
}
?>