<?
/*                D A T A - R E M O V E   F U N C T I O N S                   */

/*******************************************************************************
* Function: delete_user                                                        *
* Delete the user with ID $uid if the user is allowed to do that (admins)      *
* !! Use with care: normally you shouldn't delete users but disable them !!    *
*******************************************************************************/
function delete_user($uid) {
	
	global $logged_in, $user_prefs;
	
	// Now we do some tests. If all tests succeed, we execute the query
	// to delete the user from the database and we return 0. If there where any
	// errors we return an non-zero value, indicationg what's wrong.
	// These non-zero values are:
	// 1: invalid username/password combo
	// 2: user is not an administrator
	// 3: none/invalid uid
	// 4: unkown database error
	
	// Check if the user is logged in
	if ($logged_in != 1) {
		return 1;
	}
	
	// Check if the user is administrator
	if ($user_prefs->status != _ADMINISTRATOR_) {
		return 2;
	}
	
	// Check if user ID parameter is not empty
	if ($uid == "") {
		return 3;
	}
	
	// Execute delete query
	gpb_connect();
	$query = "DELETE FROM gpb_user WHERE uid=$uid";
	$result = mysql_query($query);
	gpb_close();
	if (!$result) {
		return 4;
	}
	
	return 0;
}

/*******************************************************************************
* Function: delete_category                                                    *
* Delete category with ID $cid if the user is allowed to do that               *
*******************************************************************************/
function delete_category($cid, $delete_subcats, $delete_topics, $delete_posts) {
	
	global $logged_in, $user_prefs;
	
	// Now we do some tests. If all tests succeed, we execute the query
	// to delete the category from the database and we return 0. If there where any
	// errors we return an non-zero value, indicationg what's wrong.
	// These non-zero values are:
	// 1: invalid username/password combo
	// 2: user is not an administrator
	// 3: none/invalid cid
	// 4: unkown database error
	
	// Check if the user is logged in
	if ($logged_in != 1) {
		return 1;
	}
	
	// Check if the user is administrator
	if ($user_prefs->status != _ADMINISTRATOR_) {
		return 2;
	}
	
	// Check if the subcat ID is empty
	if ($cid == "") {
		return 3;
	}
	
	gpb_connect();
	
	// select all subcategory ID's in the category
	$query = "SELECT sid FROM gpb_subcat WHERE cid=$cid";
	$result = mysql_query($query);
	
	if ($result) {
		while ($row = mysql_fetch_array($result)) {
			
			// select all topic ID's in the subcategory
			$sid = $row['sid'];
			$query2 = "SELECT tid FROM gpb_topic WHERE sid=$sid";
			$result2 = mysql_query($query2);
			
			// delete posts
			if (($result) && ($delete_posts == 1)) {
				while ($row2 = mysql_fetch_array($result2)) {
					$tid = $row2['tid'];
					$query3 = "DELETE FROM gpb_post WHERE tid=$tid";
					$result3 = mysql_query($result);
				}
			}
			
			// delete topics
			if ($delete_topics == 1) {
				$query2 = "DELETE FROM gpb_topic WHERE sid=$sid";
				$result2 = mysql_query($query2);
			}
		}
	}
	
	// delete subcategories
	if ($delete_subcat == 1) {
		$query = "DELETE FROM gpb_subcat WHERE cid=$cid";
		$result = mysql_query($query);
	}
	
	// delete category
	$query = "DELETE FROM gpb_cat WHERE cid=$cid";
	$result = mysql_query($query);
	
	gpb_close();
	
	if (!$result) {
		return 4;
	}
	
	return 0;
}

/*******************************************************************************
* Function: delete_subcategory(...)                                            *
* Delete subcategory with ID $sid if the user is allowed to do that            *
*******************************************************************************/
function delete_subcategory($sid, $delete_topics, $delete_posts) {
	
	global $logged_in, $user_prefs;
	
	// Now we do some tests. If all tests succeed, we execute the query
	// to delete the subcategory from the database and we return 0. If there where any
	// errors we return an non-zero value, indicationg what's wrong.
	// These non-zero values are:
	// 1: invalid username/password combo
	// 2: user is not an administrator
	// 3: none/invalid sid
	// 4: unkown database error
	
	// Check if the user is logged in
	if ($logged_in != 1) {
		return 1;
	}
	
	// Check if the user is administrator
	if ($user_prefs->status != _ADMINISTRATOR_) {
		return 2;
	}
	
	// check if the subcat ID is empty
	if ($sid == "") {
		return 3;
	}
	
	gpb_connect();
	
	// delete posts
	if ($delete_posts == 1) {
		$query = "SELECT tid FROM gpb_topic WHERE sid=$sid";
		$result = mysql_query($query);
		if ($result) {
			while ($row = mysql_fetch_array($result)) {
				$tid = $row['tid'];
				$query2 = "DELETE FROM gpb_post WHERE tid=$tid";
				$result2 = mysql_query($query2);
			}
		}
	}
	
	// delete topics
	if ($delete_topics == 1) {
		$query = "DELETE FROM gpb_topic WHERE sid=$sid";
		$result = mysql_query($query);
	}
	
	// delete subcategory
	$query = "DELETE FROM gpb_subcat WHERE sid=$sid";
	$result = mysql_query($query);
	
	gpb_close();
	
	return 0;
}

/*******************************************************************************
* Function: delete_topic                                                       *
* Delete topic with ID $tid if the user is allowed to do that                  *
*******************************************************************************/
function delete_topic($tid) {
	
	global $logged_in, $user_prefs;
	
	// Now we do some tests. If all tests succeed, we execute the query
	// to delete the topic from the database and we return 0. If there where any
	// errors we return an non-zero value, indicationg what's wrong.
	// These non-zero values are:
	// 1: invalid username/password combo
	// 2: user is not an administrator
	// 3: none/invalid pid
	// 4: unkown database error
	
	// Check if the user is logged in
	if ($logged_in != 1) {
		return 1;
	}
	
	// Check if the user is administrator
	if ($user_prefs->status != _ADMINISTRATOR_) {
		return 2;
	}
	
	// check if topic ID is empty
	if ($pid == "") {
		return 3;
	}
	
	gpb_connect();
	
	// first collect some info about the topic
	$query = "SELECT sid, num_topics, num_posts FROM gpb_subcat WHERE tid=$tid";
	$result = mysql_query($query);
	
	if ($result) {
		while ($row = mysql_fetch_array($result)) {
			$sid = $row['sid'];
			$subcat_num_topics = $row['num_topics'];
			$subcat_num_posts = $row['num_posts'];
		}
	}
	else {
		gpb_close();
		return 4;
	}
	
	// and collect some info about the topic
	$query = "SELECT num_posts FROM gpb_topic WHERE tid=$tid";
	$result = mysql_query($query);
	
	if ($result) {
		while ($row = mysql_fetch_array($result)) {
			$num_posts = $row['sid'];
		}
	}
	else {
		gpb_close();
		return 4;
	}
	
	// delete the posts in the topic
	$query = "DELETE FROM gpb_post WHERE tid=$tid";
	$result = mysql_query($query);
	
	// delete the topic itself
	$query = "DELETE FROM gpb_topic WHERE tid=$tid";
	$result = mysql_query($query);
	
	// Select last_pid and the num_posts of the newest topic
	$query = "SELECT gpb_post.pid, gpb_topic.num_posts FROM gpb_post, gpb_topic
			  WHERE gpb_topic.tid = gpb_post.tid 
				AND gpb_topic.sid = $old_sid 
			  ORDER BY gpb_post.timestamp DESC LIMIT 1;";
	$result = mysql_query ($query);
	$subcat_last_pid = 0;
	if ($result) {
		while ($row = mysql_fetch_array ($result)) {
			$topic_last_pid = $row['pid'];
			$topic_num_posts = $row['num_posts'];
		}
	}
	
	// update subcategory table
	$query = "UPDATE gpb_subcat SET num_topics=num_topics-1, num_posts=num_posts-".$topic_num_posts." last_pid=$last_pid WHERE sid=$sid";
	$result = mysql_query ($query);
	
	gpb_close();
	return 0;
}

/*******************************************************************************
* Function: delete_post                                                        *
* Delete post with ID $pid if the user is allowed to do that                   *
*******************************************************************************/
function delete_post($pid) {
	
	global $logged_in, $user_prefs;
	
	// Now we do some tests. If all tests succeed, we execute the query
	// to delete the post from the database and we return 0. If there where any
	// errors we return an non-zero value, indicationg what's wrong.
	// These non-zero values are:
	// 1: invalid username/password combo
	// 2: user is not an administrator
	// 3: none/invalid pid
	// 9: unkown database error
	
	// Check if the user is logged in
	if ($logged_in != 1) {
		return 1;
	}
	
	// Check if the user is administrator
	if ($user_prefs->status < _MODERATOR_) {
		return 2;
	}
	
	// Check if post ID is empty
	if ($pid == "") {
		return 3;
	}
	
	// Check if pid exists
	gpb_connect();
	$query = "SELECT pid FROM gpb_post WHERE pid=$pid";
	$result = mysql_query($query);
	gpb_close();
	if (!$result) {
		return 3;
	}
	
	// Check if the pid is the last
	gpb_connect();
	$query = "SELECT gpb_topic.last_pid FROM gpb_post, gpb_topic
			  WHERE gpb_topic.tid = gpb_post.tid
			    AND gpb_post.pid = $pid";
	$result = mysql_query($query);
	gpb_close();
	if ($result) {
		while ($row = mysql_fetch_array($result)) {
			$topic_last_pid = $row['last_pid'];
		}
	}
	
	// TODO
	
	// Execute delete query
	gpb_connect();
	$query = "DELETE FROM gpb_post WHERE pid=$pid";
	$result = mysql_query($query);
	gpb_close();
	if (!$result) {
		return 4;
	}
	
	return 0;
}
?>