<?
/*                    S E A R C H   F U N C T I O N S                         */


/*****************************************************************************
* Function: gpb_search (...)                                                 *
* Return an array with topics which are found by the given conditions        *
*****************************************************************************/
function gpb_search ($term, $addterms, $subcats, $sortby, $searchboth) {
	
	global $user_prefs;
	
	$term = trim($term);
	
	// Check the input
	if ($term == "") {
		return NULL;
	}
	
	// Split the terms (user one or more spaces (or tabs) as separator)
	$terms = split ("[ ]+", addslashes ($term));
	$numterms = count($terms);
	
	// Initial query
	$query = "SELECT gpb_topic.tid, gpb_topic.ttitle, gpb_subcat.stitle, gpb_subcat.abbrev,
	          gpb_user.uid, gpb_user.username, gpb_topic.num_posts, gpb_topic.icon,
		  	  gpb_post.timestamp, gpb_topic.sid
		      FROM gpb_topic, gpb_post, gpb_subcat, gpb_user";
	
	// Do we have to search in posttexts, topictitle or both?
	for ($i = 0; $i < $numterms; $i++) {
		if ($searchboth == "text") {
			$add[$i] = "(gpb_post.text LIKE '%$terms[$i]%')";
		}
		else if ($searchboth == "title") {
			$add[$i] = "(gpb_topic.ttitle LIKE '%$terms[$i]%')";
		}
		else {
			$add[$i] = "((gpb_post.text LIKE '%$terms[$i]%') OR (gpb_topic.ttitle LIKE '%$terms[$i]%'))";
		}
	}
	
	// Do we want ANY of the terms or ALL?
	if ($addterms == "any") {
		$AndOr = " OR ";
	}
	else {
		$AndOr = " AND ";
	}
	
	// Add first term to initial query
	$query .= " WHERE ( $add[0]";
	
	// Add all the next terms (if there ary)
	for ($i = 1; $i < $numterms; $i++) {
		$query .= "$AndOr $add[$i]";
	}
	
	// Add a closing bracket
	$query .= " )";
	
	// Search in one or in all subcategories?
	$query .= " AND (";
	for ($i = 0; $i < count($subcats); $i++) {
		$query .= "gpb_subcat.sid = ".$subcats[$i]."";
		if ($i != count($subcats) - 1) {
			$query .= " OR ";
		}
	}
	$query .= ")";
	
	// Reduce the results a littlebit...
	$query .= " AND gpb_post.uid = gpb_user.uid AND gpb_topic.sid = gpb_subcat.sid AND gpb_post.tid = gpb_topic.tid";
	
	// Normal users may not access moderator only stuff
	if ($user->status < _MODERATOR_) {
		$query .= " AND gpb_subcat.moderator_only != 1";
	}
	
	// Yeah, we like order in our chaos :)
	$query .= " ORDER BY $sortby";
	
	// Thousends of results? I don't think so :)
	$query .= " LIMIT 50";
	
	gpb_connect ();
	$result = mysql_query ($query);
	if ($result) {
		$c = 1;
		while ($row = mysql_fetch_object ($result)) {
			$search_results[$c]->tid = $row->tid;
			$search_results[$c]->ttitle = $row->ttitle;
			$search_results[$c]->sid = $row->sid;
			$search_results[$c]->stitle = $row->stitle;
			$search_results[$c]->abbrev = $row->abbrev;
			$search_results[$c]->timestamp = $row->timestamp;
			$search_results[$c]->uid = $row->uid;
			$search_results[$c]->username = $row->username;
			$search_results[$c]->num_posts = $row->num_posts;
			$search_results[$c]->icon = $row->icon;
			$c++;
		}
	}
	gpb_close ();
	return $search_results;
}

?>