<?php


function DateTime ($timestamp) {
// $timestamp is a UNIX timestamp
// returns the date in format: 31 Oktober 2001, 16:16 (Where monthname (Oktober) is in native language)
	global $lstMonth;
	$month_num = strftime("%m", $timestamp);
	if ($month_num[0] == "0") {
		$month_num = $month_num[1];
	}
	return strftime("%e", $timestamp)." ".$lstMonth[$month_num]." ".strftime("%Y, %H:%M", $timestamp);
}


function WeekdayDate ($timestamp) {
// $timestamp is a UNIX timestamp
// returns the date in format: Dinsdag, 31 Oktober 2001, (Where monthname (Oktober) is in native language)
	global $lstMonth, $lstDay;
	$month_num = strftime("%m", $timestamp);
	if ($month_num[0] == "0") {
		$month_num = $month_num[1];
	}
	return $lstDay[strftime("%u", $timestamp)].strftime(", %e", $timestamp)." ".$lstMonth[$month_num]." ".strftime("%Y", $timestamp);
}


function BirthdayDate ($date) {
// $date is a date (YYYY-MM-DD)
// returns the date in format: Dinsdag, 8 Oktober 1974 (Where monthname (Oktober) and weekday (Dinsdag) are in native language)
	global $lstMonth, $lstDay;
	$year = substr ($date, 0, 4);
	$month = substr ($date, 5, 2);
	$day = substr ($date, 8, 2);
	
	if ($month[0] == "0") {
		$monthname = $lstMonth[$month[1]];
	}
	else {
		$monthname = $lstMonth[$month];
	}
	
	if ($day[0] == "0") {
		$day = $day[1];
	}
	
	$birthday = $day." ".$monthname." ".$year;
	
	// if date is later than 1 jan 1970, get the weekday
	if (strtotime ($date) > 0) {
		$weekday = $lstDay[strftime ("%u", strtotime ($date))];
		$birthday = $weekday.", ".$birthday;
	}
	return $birthday;
}


function DayTime ($timestamp) {
// $timestamp is a UNIX timestamp
// returns the date in format: Maandag, 16:16 (Where weekday (Maandag) is in native language)
	global $lstDay;
	$weekday = $lstDay[strftime ("%u", $timestamp)];

	return $weekday.", ".strftime("%H:%M", $timestamp);
}


function NumberedPages ($url, $page, $pagecount, $extra) {
// $url = blablabla without the '&page=x'
// $page = current page (0 is none)
// $pagecount = total number of pages
// $extra = add "PREV" and "NEXT" link if $extra=1, else no PREV" and "NEXT" links
	global $strPrev, $strNext;	
	$result = "";
	
	// The PREVIOUS page
	if (($page > 1) && ($extra == 1)) {
		// Add a 'previous-link'
		$result .= "<A HREF=\"$url&page=".($page-1)."\">$strPrev</A> ";
	}
	
	// We want:
	// page 1, 2 and 3
	// current page-1, current page and current page+1
	// last page
	for ($i=1; $i<=$pagecount; $i++) {
		if (($i<=3) || ($i==$pagecount) || ($i==($page-1)) || ($i==$page) || ($i==($page+1))) {
			if ($i != $page) {
				$result .= "<A HREF=\"$url&page=".$i."\">[$i]</A> ";
			}
			else { 
				$result .= "<U>$i</U> ";
			}
		}
	}
	
	// The NEXT page
	if (($page < $pagecount) && ($page != 0) && ($extra == 1)) {
		// Add a 'next-link'
		$result .= "<A HREF=\"$url&page=".($page+1)."\">$strNext</A> ";
	}
	
	return $result;
}

?>